#!/usr/bin/ruby

require 'net/http'
require 'net/https'
require 'uri'
require 'hpricot' 
require 'timeout'
require 'bankcrawler.rb'

$blacklist = [
	"www.servicecu.org"
]
$setsize = 10
$set = 80

blzlist = Hash.new
#failed_banks = Array.new
#blz_secure_links = Hash.new
#blz_insec_links = Hash.new
#blz = ARGV[0]

# $stderr.puts blz

f = File.new("BLZ-Liste_FINAL_221009.csv")
begin
    while (line = f.readline)
        toks = line.chomp.split("\t")
	blz = toks[0].gsub('"', '')
	url = toks[3].gsub('"', '')
	if blzlist.has_key?(blz)
		# $stderr.puts("Dublette: " + blz + " - " + url + " Alt: " + blzlist[blz])
	end
	blzlist[blz] = url
    end
rescue EOFError
    f.close
end

valid_hosts = Array.new
valid_ips = Array.new

blzlist.each { |k,v|
	# $stderr.puts("Processing: " + k + " - " + v)
	# begin
	if k.to_i == ARGV[0].to_i
		puts "=== Crawling " + v
		x = SinglePage.new(v, 0.0, k.to_i)
		puts "=== Dumping linked HTTP-hosts "
		x.retrieve_hostprotos.each { |h|
			$stderr.puts(h["host"].to_s) if h["proto"] == "http"
			valid_hosts.push(h["host"].to_s)
		}
		puts "=== Dumping linked HTTPS-hosts "
		x.retrieve_hostprotos.each { |h|
			$stderr.puts(h["host"].to_s) if h["proto"] == "https"
		}
		# rescue Timeout::Error
		# end
	end
}

valid_hosts.uniq!

# Now dig the IP adresses

puts "=== Digging IP addresses "
valid_hosts.each { |host|
	inside_answer = false
	if true == false # system("which dig")
		IO.popen("dig '" + host + "'") { |io|
			while io.gets
				toks = $_.split
				inside_answer = true if toks[1] =~ /ANSWER/
				inside_answer = false if $_.strip == ''
				if inside_answer == true && !toks[4].nil? && toks[3] == "A"
					valid_ips.push(toks[4])
				end
			end
		}
	else
		IO.popen("nslookup '" + host + "'") { |io|
			while io.gets
				toks = $_.split
				inside_answer = true if toks[0] =~ /^Name:/
				if inside_answer == true && !toks[1].nil? && toks[0] =~ /^Address:/
					valid_ips.push(toks[1])
				elsif inside_answer == true && !toks[2].nil? && toks[0] =~ /^Address/ && toks[1] =~ /:$/
					valid_ips.push(toks[2])
				end
			end
		}
	end
}

valid_ips.uniq.each { |ip| puts ip }

puts "=== Dumping SMACK netlabel file "

outdir = "/tmp"
outdir = "/etc/smack/banks" if system("test -d /etc/smack/banks")

# outfile = File.open("smack.netlabel.txt", 'w')
# outfile.write("127.0.0.1/32 @\n")
# outfile.write("192.168.0.0/16 @\n")
# outfile.write("172.16.0.0/16 @\n")
# outfile.write("10.0.0.0/16 @\n")
# outfile.write("169.254.0.0/16 @\n")
ofcount = 0
valid_ips.uniq.each { |ip| 
	outfile = File.open(outdir + "/smack.netlabel." + sprintf("%03d", ofcount) + ".txt", 'w')
	outfile.write(ip + " outgoing\n") 
	outfile.close
	ofcount += 1
}
# outfile.close

# puts $already_checked.join